VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   7140
   ClientLeft      =   810
   ClientTop       =   1095
   ClientWidth     =   5040
   LinkTopic       =   "Form1"
   ScaleHeight     =   7140
   ScaleWidth      =   5040
   Begin VB.Frame Frame3 
      Caption         =   "Teil 3 - Feature unterdrcken oder Unterdrckung aufheben"
      Height          =   1455
      Left            =   120
      TabIndex        =   10
      Top             =   5040
      Width           =   4695
      Begin VB.CheckBox chkSuppress 
         Caption         =   "Rebuild nach Unterdrckungsstatus ndern"
         Height          =   255
         Left            =   240
         TabIndex        =   14
         Top             =   1080
         Value           =   1  'Aktiviert
         Width           =   4335
      End
      Begin VB.OptionButton optSuppress 
         Caption         =   "Unterdrckund aufheben"
         Height          =   375
         Index           =   1
         Left            =   2280
         TabIndex        =   13
         Top             =   600
         Width           =   2295
      End
      Begin VB.OptionButton optSuppress 
         Caption         =   "Unterdrcken"
         Height          =   375
         Index           =   0
         Left            =   2280
         TabIndex        =   12
         Top             =   360
         Value           =   -1  'True
         Width           =   1695
      End
      Begin VB.CommandButton cmdSuppress 
         Caption         =   "Feature ..."
         Height          =   375
         Left            =   240
         TabIndex        =   11
         Top             =   480
         Width           =   1575
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Teil 2 - Konfigurationen auslesen und verndern "
      Height          =   2895
      Left            =   120
      TabIndex        =   5
      Top             =   2040
      Width           =   4695
      Begin VB.ListBox lstConfiguration 
         Height          =   1230
         Left            =   120
         TabIndex        =   8
         Top             =   1200
         Width           =   4455
      End
      Begin VB.CommandButton cmdScanConfiguration 
         Caption         =   "Configs auslesen"
         Height          =   375
         Left            =   3000
         TabIndex        =   7
         Top             =   720
         Width           =   1575
      End
      Begin VB.CheckBox chkRebuild 
         Caption         =   "Rebuild nach Konfigurationsauswahl"
         Height          =   255
         Left            =   120
         TabIndex        =   6
         Top             =   2520
         Value           =   1  'Aktiviert
         Width           =   4455
      End
      Begin VB.Label Label2 
         Caption         =   "Konfigurationen der gewhlten Komponente im aktiven Dokument erst auslesen, dann durch Auswahl ndern"
         Height          =   735
         Left            =   120
         TabIndex        =   9
         Top             =   480
         Width           =   2775
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Teil 1 - komponentennamen auslesen "
      Height          =   1815
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   4695
      Begin VB.ListBox lstAssembly 
         Height          =   840
         Left            =   120
         TabIndex        =   3
         Top             =   840
         Width           =   4455
      End
      Begin VB.CommandButton cmdScanAssembly 
         Caption         =   "BG auslesen"
         Height          =   375
         Left            =   2880
         TabIndex        =   2
         Top             =   360
         Width           =   1695
      End
      Begin VB.Label Label1 
         Caption         =   "Listbox mit den Komponenten der Baugruppe"
         Height          =   375
         Left            =   120
         TabIndex        =   4
         Top             =   360
         Width           =   2535
      End
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   375
      Left            =   3720
      TabIndex        =   0
      Top             =   6720
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' als Demo, wie man in Baugruppen die Komponenten ausliest
Private Sub cmdExit_Click()
    ' Programm verlassen
    End
End Sub

Private Sub cmdScanAssembly_Click()
    ' Prozedur liest von der aktuellen Baugruppe in SolidWorks die Komponenten
    ' aus und listet diese im Listview auf
    
    Dim SwApp As Object
    Dim AssemblyDoc As Object
    Dim Configuration As Object
    Dim RootComponent As Object
    
    Dim ret As Boolean
    Dim i As Long
    
    ' ans SolidWorks anhngen
    Set SwApp = CreateObject("SldWorks.Application")
    Set AssemblyDoc = SwApp.ActiveDoc
    
    If AssemblyDoc Is Nothing Then
        MsgBox ("Kein Modell geffnet")
        Exit Sub
    End If

    ' ausserdem funktioniert das so nur mit Parts, also sollte das aktive
    ' Dokument auch ein Part sein
    If AssemblyDoc.GetType() <> swDocASSEMBLY Then
        MsgBox ("Funktioniert nur mit Baugruppen")
        Exit Sub
    End If

    ' die Listbox leeren
    lstAssembly.Clear

    ' wenn ntig alle Lightweights auflsen
    'ret = AssemblyDoc.ResolveAllLightWeightComponents(False)
    
    ' die aktuelle Konfiguration der Baugruppe ermitteln
    Set Configuration = AssemblyDoc.GetActiveConfiguration()
    
    ' Ausgangspunkt fr den Ritt durch die Baugruppe ist die Rootkomponente
    ' also die Baugruppe selbst. Wenn keine Rootkomponente da ist, brauchen
    ' wir auch auch nichts weiter machen (leere Baugruppe), ansonsten rufen
    ' wir die rekursion auf, die durch die Baugruppe klappert.
    
    Set RootComponent = Configuration.GetRootComponent()
    If Not RootComponent Is Nothing Then
        Call ScanAssemblyRecursive(RootComponent)
    End If

    
End Sub

Sub ScanAssemblyRecursive(Component As Object)
    
    ' von hier aus ermittelt man jetzt die Kinderlein, wenn man das ber
    ' mehrere Ebenen machen will, muss das rekursiv gemacht werden, siehe
    ' Beispielprogramm in der API-Hilfe

    Dim i As Integer
    Dim Children As Variant
    Dim Child As Object
 
    Children = Component.GetChildren
    For i = 0 To UBound(Children)
        ' dann holen wir uns fr das sptere Selektieren den Objektnamen
        ' und tragen den in der Listbox ein
        Set Child = Children(i)
        lstAssembly.AddItem Child.Name
        '
        ' und dann versuchen wieder rekursiv Kinder dieser Komponente zu
        ' finden, wenn keine da sind geht's auf dieser Ebene weiter
        Call ScanAssemblyRecursive(Child)
    Next i
    
End Sub

Private Sub cmdScanConfiguration_Click()
    ' im aktiven Assembly wird die erste selektierte Komponente nach Konfigurationen
    ' untersucht und diese in der Listbox dargestellt.
    Dim SwApp As Object
    Dim AssemblyDoc As Object
    Dim ModelDoc As Object
    Dim SelMgr As Object
    Dim SelObj As Object
    
    Dim anzahlKonfigs As Long
    Dim KonfigNamen As Variant

    Dim i As Long
    
    ' ans SolidWorks anhngen
    Set SwApp = CreateObject("SldWorks.Application")
    Set AssemblyDoc = SwApp.ActiveDoc
    
    If AssemblyDoc Is Nothing Then
        MsgBox ("Kein Modell geffnet")
        Exit Sub
    End If

    ' ausserdem funktioniert das so nur mit Parts, also sollte das aktive
    ' Dokument auch ein Part sein
    If AssemblyDoc.GetType() <> swDocASSEMBLY Then
        MsgBox ("Funktioniert nur mit Baugruppen")
        Exit Sub
    End If

    lstConfiguration.Clear
    ' wenn ntig alle Lightweights auflsen
    'ret = AssemblyDoc.ResolveAllLightWeightComponents(False)
    
    ' dann die Selektion auswerten, dazu erstmal den Selektionsmanager aufrufen
    Set SelMgr = AssemblyDoc.SelectionManager()
    
    ' dann schauen, ob berhaupt eine Komponente selektiert ist
    If (SelMgr.GetSelectedObjectCount <> 0) Then
        ' dann das erste selektierte Element holen und schauen, ob's eine Komponente ist
        Set SelObj = SelMgr.GetSelectedObject3(1)
        If (SelMgr.GetSelectedObjectType(1) = swSelCOMPONENTS) Then
            ' dann die konfigurationen auslesen, dazu erstmal das Modell
            ' dieser Komponente holen, da nur dort die Konfigurationen gelesen
            ' werden knnen
            Set ModelDoc = SelObj.GetModelDoc
            '
            ' dann die Konfigurationsnamen ermitteln und in die zweite Liste eintragen
            anzahlKonfigs = ModelDoc.GetConfigurationCount()
            KonfigNamen = ModelDoc.GetConfigurationNames()
            For i = 0 To (anzahlKonfigs - 1)
                lstConfiguration.AddItem KonfigNamen(i)
            Next
            '
        Else
            MsgBox "Keine Komponente selektiert"
        End If
    Else
        MsgBox " Nichts selektiert"
    End If



End Sub

Private Sub cmdSuppress_Click()
    ' dann werden alle selektierten Elemente kontrolliert und alle
    ' Feature dabei unterdrckt bzw. Unterdrckung aufgehoben
    
    Dim SwApp As Object
    Dim AssemblyDoc As Object
    Dim ModelDoc As Object
    Dim SelMgr As Object
    Dim SelObj As Object
    Dim i  As Long
    Dim ret As Boolean
    
    
    ' ans SolidWorks anhngen
    Set SwApp = CreateObject("SldWorks.Application")
    Set AssemblyDoc = SwApp.ActiveDoc
    
    If AssemblyDoc Is Nothing Then
        MsgBox ("Kein Modell geffnet")
        Exit Sub
    End If

    ' ausserdem funktioniert das so nur mit Parts, also sollte das aktive
    ' Dokument auch ein Part sein
    If AssemblyDoc.GetType() <> swDocASSEMBLY Then
        MsgBox ("Funktioniert nur mit Baugruppen")
        Exit Sub
    End If

    ' wenn ntig alle Lightweights auflsen
    'ret = AssemblyDoc.ResolveAllLightWeightComponents(False)
    
    ' dann die Selektion auswerten, dazu erstmal den Selektionsmanager aufrufen
    Set SelMgr = AssemblyDoc.SelectionManager()
    
    ' dann schauen, ob berhaupt eine Komponente selektiert ist
    If (SelMgr.GetSelectedObjectCount <> 0) Then
        ' dann das erste selektierte Element holen und schauen, ob's eine Komponente ist
        For i = 1 To SelMgr.GetSelectedObjectCount
            Set SelObj = SelMgr.GetSelectedObject3(i)
            
            ' in diesem beispiel bearbeiten wir nur die Bodyfeatures
            
            If (SelMgr.GetSelectedObjectType(i) = swSelBODYFEATURES) Then
                ' das Feature unterdrcken
                If (optSuppress(0).Value = True) Then
                    ret = SelObj.SetSuppression(swSuppressFeature)
                Else
                    ret = SelObj.SetSuppression(swUnSuppressFeature)
                End If
            End If
        Next i
        ' und noch das Rebuild falls notwendig
        If chkSuppress.Value = 1 Then
            AssemblyDoc.EditRebuild
        End If
    Else
        MsgBox " Nichts selektiert"
    End If

End Sub

Private Sub lstConfiguration_Click()
    ' in der ausgewhlten komponente die in der Listbox angeklickte Konfiguration setzen
    Dim SwApp As Object
    Dim AssemblyDoc As Object
    Dim ModelDoc As Object
    Dim SelMgr As Object
    Dim SelObj As Object
    
    Dim anzahlKonfigs As Long
    Dim KonfigNamen As Variant

    Dim i As Long
    Dim gefunden As Boolean
    
    gefunden = False
    
    ' ans SolidWorks anhngen
    Set SwApp = CreateObject("SldWorks.Application")
    Set AssemblyDoc = SwApp.ActiveDoc
    
    If AssemblyDoc Is Nothing Then
        MsgBox ("Kein Modell geffnet")
        Exit Sub
    End If

    ' ausserdem funktioniert das so nur mit Parts, also sollte das aktive
    ' Dokument auch ein Part sein
    If AssemblyDoc.GetType() <> swDocASSEMBLY Then
        MsgBox ("Funktioniert nur mit Baugruppen")
        Exit Sub
    End If

    ' wenn ntig alle Lightweights auflsen
    'ret = AssemblyDoc.ResolveAllLightWeightComponents(False)
    
    ' dann die Selektion auswerten, dazu erstmal den Selektionsmanager aufrufen
    Set SelMgr = AssemblyDoc.SelectionManager()
    
    ' dann schauen, ob berhaupt eine Komponente selektiert ist
    If (SelMgr.GetSelectedObjectCount <> 0) Then
        ' dann das erste selektierte Element holen und schauen, ob's eine Komponente ist
        Set SelObj = SelMgr.GetSelectedObject3(1)
        If (SelMgr.GetSelectedObjectType(1) = swSelCOMPONENTS) Then
            ' dann die konfigurationen auslesen, dazu erstmal das Modell
            ' dieser Komponente holen, da nur dort die Konfigurationen gelesen
            ' werden knnen
            Set ModelDoc = SelObj.GetModelDoc
            ' dann die Konfigurationsnamen ermitteln und mit der Auswahl in der
            ' Lstbox vergleichen, wenn gefunden
            anzahlKonfigs = ModelDoc.GetConfigurationCount()
            KonfigNamen = ModelDoc.GetConfigurationNames()
            For i = 0 To (anzahlKonfigs - 1)
                If (KonfigNamen(i) = lstConfiguration.List(lstConfiguration.ListIndex)) Then
                    ' jetzt aber dran denken, dass wir die angezeigte Konfiguration
                    ' der Komponente ndern wollen, also das SelObj benutzen
                    SelObj.ReferencedConfiguration = KonfigNamen(i)
                    gefunden = True
                    
                    ' dann noch schauen, ob ein Rebuild gemacht werden soll. Wenn man es
                    ' nicht macht, wird die neue Konfiguration noch nicht im Featuremananger
                    ' gezeigt.
                    If chkRebuild.Value = 1 Then
                        AssemblyDoc.EditRebuild
                    End If
                End If
            Next
            '
        Else
            MsgBox "Keine Komponente selektiert"
        End If
    Else
        MsgBox " Nichts selektiert"
    End If
        
    If gefunden = False Then
        MsgBox "Gewhlte Konfiguration konnte nicht gesetzt werden"
    End If
    
End Sub
